/* Helper */
abstract sig Bool{}{}
one sig True extends Bool{}
one sig False extends Bool{}

abstract sig Student{
  id: one ID,
  major: one Major,
  university: lone University,
  legal: Bool,
  classmates: set Student,
}

sig Grad extends Student{}
sig Undergrad extends Student{}
sig ID{}
sig Major{}
sig University{}

fact unique_ids {
  all disj s, t: Student | s.id != t.id
}

fact legal_in_university {
  all s: Student | (s.university != none) iff (s.legal = True)
}

fact classmates_have_same_majors {
  all disj s, t: Student | (s.major = t.major) iff (s in t.classmates)
}

fact no_grad_and_undergrad_are_classmates {
  all s: Grad, t: Undergrad | (s not in t.classmates) and (t not in s.classmates)
}

pred show{}

run show for 5
